#ifndef BENCHMARK_DATABASE_MANAGER_H
#define BENCHMARK_DATABASE_MANAGER_H

#include <QtTest>

#include "DatabaseManager.h"

class BenchmarkDatabaseManager: public QObject
{
    Q_OBJECT

private slots:
    void initTestCase();
    void cleanupTestCase();
    void benchmarkSetupDatabase();
    void benchmarkInsertAudioFile();
    void benchmarkGetAudioFiles();
    void benchmarkClearAudioFiles();
    void benchmarkCreateTestSession();
    void benchmarkUpdateTestSessionEndTime();
    void benchmarkGetSessionsWithDuration();
    void benchmarkInsertTrial();
    void benchmarkGetTrialsForSession();
    void benchmarkGetAverageTrialsPerSession();
    void benchmarkGetAverageResponseTimePerTrial();
    void benchmarkGetAverageDurationPerSession();
    void benchmarkGetAverageSuccessPerSession();

private:
    DatabaseManager* dbManager;
};

#endif // BENCHMARK_DATABASE_MANAGER_H
