#include "TestJackClientAudioEngine.h"


void TestJackClientAudioEngine::initTestCase()
{
    jackClientAudioEngine = new JackClientAudioEngine();
}

void TestJackClientAudioEngine::cleanupTestCase()
{
    delete jackClientAudioEngine;
}

void TestJackClientAudioEngine::testAudioCallback()
{
    const jack_nframes_t nframes = 256;
    const unsigned int num_channels = 2;  // Assume stereo audio
    // Create mock input and output buffers.
    JackClientAudioEngine::audioBufVector inBufs(num_channels);
    JackClientAudioEngine::audioBufVector outBufs(num_channels);
    // Fill in the buffers
    for (unsigned int i = 0; i < num_channels; ++i) {
        inBufs[i] = new float[nframes]();
        outBufs[i] = new float[nframes]();
    }
    // Invoke the method and check the result
    int result = jackClientAudioEngine->audioCallback(nframes, inBufs, outBufs);
    // Check the result
    QCOMPARE(result, 0);
    // Free the allocated memory!
    for (unsigned int i = 0; i < num_channels; ++i) {
        delete[] inBufs[i];
        delete[] outBufs[i];
    }
}

void TestJackClientAudioEngine::testSetVolumeLevel()
{
    jackClientAudioEngine->setVolumeLevel(99);
    // TODO: Expose getter and verify.
}

void TestJackClientAudioEngine::testSetFilterConfig()
{
    jackClientAudioEngine->setFilterConfig(2000, 5);
    // TODO: Expose getter and verify.
}

void TestJackClientAudioEngine::testSetActiveFilterType()
{
    jackClientAudioEngine->setActiveFilterType(FilterType::HighShelf);
    // TODO: Expose getter and verify.
}
